#!/bin/sh
#
# Rubi's Ultimate Backup Implementation
#
# Version 3.2, (C) 3.1999 by Beat Rubischon <beat@rubis.ch>
#                  8.1999 by Beat Rubischon <beat.rubischon@trivadis.com>
#                  2.2000 by Beat Rubischon <beat@rubis.ch>
#                  2.2004 by Beat Rubischon <rubischon@phys.ethz.ch>
#                  7.2007 by Beat Rubischon <beat@0x1b.ch>
#                 10.2010 by Beat Rubischon <beat.rubischon@dalco.ch>
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# $Id: functions.sh,v 1.11 2010-10-14 11:45:40 beat Exp $
#
# Subroutines for rubi

# -----------------
# do the dirty work
# -----------------
doit () {

#
# upgrade client
    if [ "$SRCHOST" != "localhost" ]; then
	(cd /; tar cf - \
	  .$PREFIX/COPYING \
	  .$PREFIX/VERSION \
	  .$PREFIX/lib/[a-z]* ) \
	  | $SSH $SRCHOST "cd /; tar xfp -"
    fi

#
# do backup
    mkdir -p $DSTDIR
    cd $DSTDIR
    $PREFIX/lib/backup.pl "$PREFIX" "$SSH" "$MKFIFO" "$CPIO" "$RSYNC" \
      "$SRCCPIO" "$SRCRSYNC" "$SRCHOST" "$SRCPART" "$BASEDST" \
      "$DSTDIR" "$OLDDST" "$UTIME" 2>&1
    if [ $? -eq 0 ]; then
	echo $DSTDIR > $BASEDST/lastdst

#
# cleanup
        if [ -f $BASEDST/utimes ]; then
	    rm -f $BASEDST/utimes
        fi

#
# expunge
        if [ "$KEEPG" != "" ]; then
            echo "Available backups:"
            $PREFIX/lib/cleanup.pl "$BASEDST" $KEEPG $KEEPD
        else
            if [ "$KEEPS" = "" ]; then
	        $FIND $BASEDST -maxdepth 1 -ctime +$KEEPD -type d \
	          | (while read dir; do
	            echo -n "deleting $dir..."
	            rm -Rf $dir
	            rm -f $dir.log
	            echo "done."
	            done)
            else
	        $FIND $BASEDST -maxdepth 1 -ctime +$KEEPD -type d \
	          | egrep -v "$KEEPS" \
	          | (while read dir; do
	            echo -n "deleting $dir..."
	            rm -Rf $dir
	            rm -f $dir.log
	            echo "done."
	            done)
            fi
        fi

        echo
	echo "* * * Backup successfull * * *"
	echo
#
# failed
    else
	rmdir $DSTDIR 2>/dev/null
	echo
	echo "* * * Backup failed * * *"
	echo
    fi
}
